SystemOrganization addCategory: #'PBE-LightsOut'!

SimpleSwitchMorph subclass: #LOCell
	instanceVariableNames: 'mouseAction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PBE-LightsOut'!

!LOCell methodsFor: 'initialization' stamp: 'AdrianHealey 11/10/2012 19:39'!
initialize
	super initialize.
	self label: ''.
	self borderWidth: 2.
	bounds := 0@0 corner: 16@16.
	offColor := Color paleYellow.
	onColor := Color paleBlue darker.
	self useSquareCorners.
	self turnOff! !

!LOCell methodsFor: 'accessing' stamp: 'AdrianHealey 11/11/2012 20:58'!
mouseAction: aBlock
	^mouseAction := aBlock! !

!LOCell methodsFor: 'event handling' stamp: 'AdrianHealey 11/11/2012 21:00'!
mouseUp: anEvent
	mouseAction value! !

BorderedMorph subclass: #LOGame
	instanceVariableNames: 'cells'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PBE-LightsOut'!

!LOGame methodsFor: 'initialization' stamp: 'AdrianHealey 11/11/2012 20:49'!
cellsPerSide 
	"Le nombre de cellules le long de chaque ct du jeu"
	^ 10! !

!LOGame methodsFor: 'initialization' stamp: 'AdrianHealey 11/10/2012 19:53'!
initialize
	| sampleCell width height n |
	super initialize.
	n := self cellsPerSide.
	sampleCell  := LOCell new.
	width := sampleCell width.
	height := sampleCell height.
	self bounds: (5@5 extent: ((width*n)@(height*n)) + (2 * self borderWidth)).
	cells := Matrix new: n tabulate: [ :i :j | self newCellAt: i at: j ]! !

!LOGame methodsFor: 'event handling' stamp: 'AdrianHealey 11/11/2012 21:09'!
mouseMove: enEvent! !

!LOGame methodsFor: 'initialization' stamp: 'AdrianHealey 11/11/2012 21:05'!
newCellAt: i at: j
	"Cre une cellule  la position (i,j) et l'ajoute dans ma reprsentation graphique  la position 	correcte. Retourne une nouvelle cellule"
	| c origin |
	c := LOCell new.
	origin := self innerBounds origin.
	self addMorph: c.
	c position: ((i - 1) * c width) @ ((j - 1) * c height) + origin.
	c mouseAction: [self toggleNeighboursOfCellAt: i at: j].
	^c! !

!LOGame methodsFor: 'game logic' stamp: 'AdrianHealey 11/11/2012 20:55'!
toggleNeighboursOfCellAt: i at: j
	(i > 1) ifTrue: [ (cells at: i - 1 at: j ) toggleState].
	(i < self cellsPerSide) ifTrue: [ (cells at: i + 1 at: j) toggleState].
	(j > 1) ifTrue: [ (cells at: i at: j - 1) toggleState].
	(j < self cellsPerSide) ifTrue: [ (cells at: i at: j + 1) toggleState]! !
